<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <div>
    <gdpr-popup
      v-if="!loading"
      :gdpr="gdpr"
      v-model="gdprPopup"
      v-on:declineGdpr="gdprPopup = false"
      v-on:acceptGdpr="
        adduser.gdpr = gdpr.id;
        gdprPopup = false;
        doAddUser();
      "
    ></gdpr-popup>
    <v-row>
      <v-col>
        <v-card>
          <v-card-title class="red--text"> Benutzer Anlegen </v-card-title>
          <v-card-text v-if="!loading">
            <v-alert type="success" v-if="success"> Benutzer wurde erfolgreich angelegt. </v-alert>

            <v-form ref="form" v-if="!success">
              <v-alert type="warning" v-if="error">
                Bitte folgende Fehler beheben:
                <ul>
                  <li v-for="e in error" :key="e">
                    {{ e }}
                  </li>
                </ul>
              </v-alert>

              <v-row>
                <v-col>
                  <v-text-field
                    label="Vorname"
                    prepend-icon="mdi-account-box"
                    v-model="adduser.firstname"
                    :rules="nameRules"
                    :disabled="sending"
                  />
                </v-col>
                <v-col>
                  <v-text-field
                    label="Nachname"
                    prepend-icon="mdi-account-box-outline"
                    v-model="adduser.surname"
                    :rules="nameRules"
                    :disabled="sending"
                  />
                </v-col>
              </v-row>

              <v-text-field
                label="Anzeigename"
                prepend-icon="mdi-card-account-details"
                append-icon="mdi-lightbulb-outline"
                @click:append="setDisplayNameSuggestion"
                :hint="`Empfehlung: ${displayNameSuggestion(this.adduser)}`"
                :placeholder="displayNameSuggestion(this.adduser)"
                v-model="adduser.displayName"
                :disabled="sending"
                :rules="displayNameRules"
              />

              <v-text-field
                label="E-Mail"
                prepend-icon="mdi-email"
                v-model="adduser.mail"
                :rules="[util.validateMail]"
                :disabled="sending"
              />

              <v-autocomplete
                v-model="adduser.groups"
                :items="this.items"
                item-text="name"
                item-value="id"
                label="Gruppenzugehörigkeit"
                multiple
                chips
                prepend-icon="mdi-account-multiple"
                :disabled="loading || sending"
              ></v-autocomplete>

              <v-autocomplete
                v-model="adduser.permissions"
                :items="allowedPermissions"
                multiple
                chips
                item-text="value"
                item-value="id"
                prepend-icon="mdi-account-check-outline"
                label="Rechte"
                :disabled="loading"
              >
              </v-autocomplete>

              <v-checkbox
                v-model="adduser.verified"
                :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
                :disabled="sending"
                required
              >
                <template v-slot:label>
                  Ich habe die Identität der Person mithilfe eines Ausweisdokuments überprüft oder
                  kenne ihn oder sie persönlich.
                </template>
              </v-checkbox>

              <v-text-field
                label="Passwort"
                name="password1"
                type="password"
                prepend-icon="mdi-lock"
                v-model="adduser.password1"
                :disabled="sending"
                :rules="passwordRules"
              />

              <v-text-field
                label="Passwort wiederholen"
                name="password2"
                prepend-icon="mdi-lock"
                type="password"
                v-model="adduser.password2"
                :error-messages="passwordConfirmationRule()"
                :disabled="sending"
              />

              <background-job-status
                v-if="addUserJobId"
                :jobId="addUserJobId"
                @job_completed="processJobCompleted"
              >
              </background-job-status>
            </v-form>
          </v-card-text>
          <v-card-text v-else>
            <v-progress-circular indeterminate></v-progress-circular>
          </v-card-text>
          <v-card-actions v-if="!loading">
            <v-btn
              color="orange darken-2"
              class="pa-4 white--text"
              tile
              @click="reset"
              v-if="success"
              >Weiteren Benutzer anlegen
            </v-btn>
            <v-spacer />
            <v-btn
              color="orange darken-2"
              class="pa-4 white--text"
              tile
              @click="doAddOrGdpr"
              :loading="sending"
              :disabled="sending"
              v-if="!success"
              >Anlegen
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import * as api from '../../api';
import * as util from "../../util";
import Api from '../../LegacyApi';
import Util from '../../LegacyUtil';
import GdprPopup from '../../components/GdprPopup.vue';

export default {
  components: {
    'gdpr-popup': GdprPopup,
  },
  mounted() {
    let gdprPromise = Api.defaultHandler(this, Api.getGdpr('latest')).then((result) => {
      this.gdpr = result;
    });

    let groupsPromise = Api.defaultHandler(this, Api.getAllGroups()).then((result) => {
      this.groups = result;
      this.items = Array.from(this.groups.values());
    });

    Promise.all([gdprPromise, groupsPromise]).then(() => {
      this.loading = false;
    });
  },
  data: () => {
    return {
      loading: true,
      sending: false,
      addUserJobId: null,
      success: false,
      error: null,
      groups: [],
      items: [],
      gdpr: null,
      gdprPopup: false,
      adduser: {
        firstname: '',
        surname: '',
        mail: '',
        groups: [],
        permissions: [],
        verified: false,
        password1: '',
        password2: '',
        displayName: '',
      },
      allowedPermissions: [
        'INVITE',
        'RESET_SANDBOX',
        'UPLOAD_SUPPORT_MEMBER',
        'MANAGE_GDPR',
        'FUNCTION_ACCOUNT',
      ],
      nameRules: [
        (v) => !!v || 'Dieses Feld ist benötigt',
        (v) => (v || '').length >= 2 || 'Mindestens 2 Zeichen benötigt',
        (v) => (v || '').length <= 40 || 'Maximal 40 Zeichen',
      ],
      displayNameRules: [
        (v) => !!v || 'Bitte einen Anzeigenamen wählen',
        (v) => (v || '').length >= 3 || 'Der Anzeigename muss mindestens 3 Zeichen beinhalten',
        (v) => (v || '').length <= 40 || 'Der Anzeigename darf maximal 40 Zeichen beinhalten',
        (v) =>
          RegExp('^[a-z][a-z0-9\\.]*$').test(v || '') ||
          'Nur Kleinbuchstaben, Zahlen und Punkte. Darf nur mit einem Buchstaben starten.',
      ],
      passwordRules: [
        (v) => !!v || 'Bitte ein Passwort eingeben',
        (v) => (v || '').length >= 8 || 'Das Passwort muss mindestens 8 Zeichen beinhalten',
        (v) => (v || '').length <= 400 || 'Das Passwort darf maximal 400 Zeichen beinhalten',
      ],
      util,
    };
  },
  methods: {
    reset: function () {
      this.error = null;
      this.adduser.firstname = '';
      this.adduser.surname = '';
      this.adduser.mail = '';
      this.adduser.verified = false;
      this.adduser.groups = [];
      this.adduser.permissions = [];
      this.adduser.password1 = '';
      this.adduser.password2 = '';
      this.adduser.displayName = '';
      this.adduser.gdpr = null;
      this.sending = false;
      this.addUserJobId = null;
      this.success = false;
      this.gdprPopup = false;
    },
    displayNameSuggestion: function (user) {
      return Util.displayNameSuggestion(user);
    },
    setDisplayNameSuggestion: function () {
      this.adduser.displayName = this.displayNameSuggestion(this.adduser);
    },
    passwordConfirmationRule: function () {
      return this.adduser.password1 === this.adduser.password2
        ? ''
        : 'Passwörter müssen übereinstimmen';
    },
    doAddOrGdpr: function () {
      if (!this.gdpr || this.adduser.permissions.includes('FUNCTION_ACCOUNT')) {
        this.doAddUser();
      } else {
        this.gdprPopup = true;
      }
    },
    doAddUser: function () {
      if (this.$refs.form.validate()) {
        this.$emit('clearError');
        this.sending = true;

        fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/multiservice/users?async=true', {
          method: 'PUT',
          credentials: 'include',
          body: JSON.stringify(this.adduser),
        })
          .then((response) => {
            if (response.status === 201) {
              response.json().then((data) => {
                this.addUserJobId = data.id;
              });
            } else if (response.status === 401) {
              this.$router.push('/logout');
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  this.error = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
    processJobCompleted: function (result) {
      if (api.job.isErrorResult(result)) {
        this.error = [result.error];
        this.sending = false;
      } else {
        this.success = true;
      }
    },
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>

<style scoped></style>
